Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/builder.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -1372,51 +1508,82 @@
           case 'H':
           case '?':
-            Log() << Verbose(0) << "MoleCuilder suite" << endl << "==================" << endl << endl;
-            Log() << Verbose(0) << "Usage: " << argv[0] << "[config file] [-{acefpsthH?vfrp}] [further arguments]" << endl;
-            Log() << Verbose(0) << "or simply " << argv[0] << " without arguments for interactive session." << endl;
-            Log() << Verbose(0) << "\t-a Z x1 x2 x3\tAdd new atom of element Z at coordinates (x1,x2,x3)." << endl;
-            Log() << Verbose(0) << "\t-A <source>\tCreate adjacency list from bonds parsed from 'dbond'-style file." <<endl;
-            Log() << Verbose(0) << "\t-b xx xy xz yy yz zz\tCenter atoms in domain with given symmetric matrix of (xx,xy,xz,yy,yz,zz)." << endl;
-            Log() << Verbose(0) << "\t-B xx xy xz yy yz zz\tBound atoms by domain with given symmetric matrix of (xx,xy,xz,yy,yz,zz)." << endl;
-            Log() << Verbose(0) << "\t-c x1 x2 x3\tCenter atoms in domain with a minimum distance to boundary of (x1,x2,x3)." << endl;
-            Log() << Verbose(0) << "\t-C\tPair Correlation analysis." << endl;
-            Log() << Verbose(0) << "\t-d x1 x2 x3\tDuplicate cell along each axis by given factor." << endl;
-            Log() << Verbose(0) << "\t-D <bond distance>\tDepth-First-Search Analysis of the molecule, giving cycles and tree/back edges." << endl;
-            Log() << Verbose(0) << "\t-e <file>\tSets the databases path to be parsed (default: ./)." << endl;
-            Log() << Verbose(0) << "\t-E <id> <Z>\tChange atom <id>'s element to <Z>, <id> begins at 0." << endl;
-            Log() << Verbose(0) << "\t-f/F <dist> <order>\tFragments the molecule in BOSSANOVA manner (with/out rings compressed) and stores config files in same dir as config (return code 0 - fragmented, 2 - no fragmentation necessary)." << endl;
-            Log() << Verbose(0) << "\t-g <file>\tParses a bond length table from the given file." << endl;
-            Log() << Verbose(0) << "\t-h/-H/-?\tGive this help screen." << endl;
-            Log() << Verbose(0) << "\t-L <step0> <step1> <prefix>\tStore a linear interpolation between two configurations <step0> and <step1> into single config files with prefix <prefix> and as Trajectories into the current config file." << endl;
-            Log() << Verbose(0) << "\t-m <0/1>\tCalculate (0)/ Align in(1) PAS with greatest EV along z axis." << endl;
-            Log() << Verbose(0) << "\t-M <basis>\tSetting basis to store to MPQC config files." << endl;
-            Log() << Verbose(0) << "\t-n\tFast parsing (i.e. no trajectories are looked for)." << endl;
-            Log() << Verbose(0) << "\t-N <radius> <file>\tGet non-convex-envelope." << endl;
-            Log() << Verbose(0) << "\t-o <out>\tGet volume of the convex envelope (and store to tecplot file)." << endl;
-            Log() << Verbose(0) << "\t-O\tCenter atoms in origin." << endl;
-            Log() << Verbose(0) << "\t-p <file>\tParse given xyz file and create raw config file from it." << endl;
-            Log() << Verbose(0) << "\t-P <file>\tParse given forces file and append as an MD step to config file via Verlet." << endl;
-            Log() << Verbose(0) << "\t-r <id>\t\tRemove an atom with given id." << endl;
-            Log() << Verbose(0) << "\t-R <id> <radius>\t\tRemove all atoms out of sphere around a given one." << endl;
-            Log() << Verbose(0) << "\t-s x1 x2 x3\tScale all atom coordinates by this vector (x1,x2,x3)." << endl;
-            Log() << Verbose(0) << "\t-S <file> Store temperatures from the config file in <file>." << endl;
-            Log() << Verbose(0) << "\t-t x1 x2 x3\tTranslate all atoms by this vector (x1,x2,x3)." << endl;
-            Log() << Verbose(0) << "\t-T x1 x2 x3\tTranslate periodically all atoms by this vector (x1,x2,x3)." << endl;
-            Log() << Verbose(0) << "\t-u rho\tsuspend in water solution and output necessary cell lengths, average density rho and repetition." << endl;
-            Log() << Verbose(0) << "\t-v/-V\t\tGives version information." << endl;
-            Log() << Verbose(0) << "Note: config files must not begin with '-' !" << endl;
+            DoLog(0) && (Log() << Verbose(0) << "MoleCuilder suite" << endl << "==================" << endl << endl);
+            DoLog(0) && (Log() << Verbose(0) << "Usage: " << argv[0] << "[config file] [-{acefpsthH?vfrp}] [further arguments]" << endl);
+            DoLog(0) && (Log() << Verbose(0) << "or simply " << argv[0] << " without arguments for interactive session." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-a Z x1 x2 x3\tAdd new atom of element Z at coordinates (x1,x2,x3)." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-A <source>\tCreate adjacency list from bonds parsed from 'dbond'-style file." <<endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-b xx xy xz yy yz zz\tCenter atoms in domain with given symmetric matrix of (xx,xy,xz,yy,yz,zz)." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-B xx xy xz yy yz zz\tBound atoms by domain with given symmetric matrix of (xx,xy,xz,yy,yz,zz)." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-c x1 x2 x3\tCenter atoms in domain with a minimum distance to boundary of (x1,x2,x3)." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-C <type> [params] <output> <bin output> <BinWidth> <BinStart> <BinEnd>\tPair Correlation analysis." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-d x1 x2 x3\tDuplicate cell along each axis by given factor." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-D <bond distance>\tDepth-First-Search Analysis of the molecule, giving cycles and tree/back edges." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-e <file>\tSets the databases path to be parsed (default: ./)." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-E <id> <Z>\tChange atom <id>'s element to <Z>, <id> begins at 0." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-f <dist> <order>\tFragments the molecule in BOSSANOVA manner (with/out rings compressed) and stores config files in same dir as config (return code 0 - fragmented, 2 - no fragmentation necessary)." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-F <xyz of filler> <dist_x> <dist_y> <dist_z> <epsilon> <randatom> <randmol> <DoRotate>\tFilling Box with water molecules." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-FF <MaxDistance> <xyz of filler> <dist_x> <dist_y> <dist_z> <epsilon> <randatom> <randmol> <DoRotate>\tFilling Box with water molecules." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-g <file>\tParses a bond length table from the given file." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-h/-H/-?\tGive this help screen." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-I\t Dissect current system of molecules into a set of disconnected (subgraphs of) molecules." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-j\t<path> Store all bonds to file." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-J\t<path> Store adjacency per atom to file." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-L <step0> <step1> <prefix>\tStore a linear interpolation between two configurations <step0> and <step1> into single config files with prefix <prefix> and as Trajectories into the current config file." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-m <0/1>\tCalculate (0)/ Align in(1) PAS with greatest EV along z axis." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-M <basis>\tSetting basis to store to MPQC config files." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-n\tFast parsing (i.e. no trajectories are looked for)." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-N <radius> <file>\tGet non-convex-envelope." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-o <out>\tGet volume of the convex envelope (and store to tecplot file)." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-O\tCenter atoms in origin." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-p <file>\tParse given xyz file and create raw config file from it." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-P <file>\tParse given forces file and append as an MD step to config file via Verlet." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-r <id>\t\tRemove an atom with given id." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-R <id> <radius>\t\tRemove all atoms out of sphere around a given one." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-s x1 x2 x3\tScale all atom coordinates by this vector (x1,x2,x3)." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-S <file> Store temperatures from the config file in <file>." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-t x1 x2 x3\tTranslate all atoms by this vector (x1,x2,x3)." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-T x1 x2 x3\tTranslate periodically all atoms by this vector (x1,x2,x3)." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-u rho\tsuspend in water solution and output necessary cell lengths, average density rho and repetition." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-v\t\tsets verbosity (more is more)." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-V\t\tGives version information." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "\t-X\t\tset default name of a molecule." << endl);
+            DoLog(0) && (Log() << Verbose(0) << "Note: config files must not begin with '-' !" << endl);
             return (1);
             break;
           case 'v':
+            while (argv[argptr-1][verbosity+1] == 'v') {
+              verbosity++;
+            }
+            setVerbosity(verbosity);
+            DoLog(0) && (Log() << Verbose(0) << "Setting verbosity to " << verbosity << "." << endl);
+            break;
           case 'V':
-            Log() << Verbose(0) << argv[0] << " " << VERSIONSTRING << endl;
-            Log() << Verbose(0) << "Build your own molecule position set." << endl;
+            DoLog(0) && (Log() << Verbose(0) << argv[0] << " " << VERSIONSTRING << endl);
+            DoLog(0) && (Log() << Verbose(0) << "Build your own molecule position set." << endl);
             return (1);
+            break;
+          case 'B':
+            if (ExitFlag == 0) ExitFlag = 1;
+            if ((argptr+5 >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3])) || (!IsValidNumber(argv[argptr+4])) || (!IsValidNumber(argv[argptr+5])) ) {
+              ExitFlag = 255;
+              DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for bounding in box: -B <xx> <xy> <xz> <yy> <yz> <zz>" << endl);
+              performCriticalExit();
+            } else {
+              SaveFlag = true;
+              j = -1;
+              DoLog(1) && (Log() << Verbose(1) << "Centering atoms in config file within given simulation box." << endl);
+              double * const cell_size = World::get()->cell_size;
+              for (int i=0;i<6;i++) {
+                cell_size[i] = atof(argv[argptr+i]);
+              }
+              argptr+=6;
+            }
             break;
           case 'e':
             if ((argptr >= argc) || (argv[argptr][0] == '-')) {
-              eLog() << Verbose(0) << "Not enough or invalid arguments for specifying element db: -e <db file>" << endl;
+              DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments for specifying element db: -e <db file>" << endl);
+              performCriticalExit();
             } else {
-              Log() << Verbose(0) << "Using " << argv[argptr] << " as elements database." << endl;
+              DoLog(0) && (Log() << Verbose(0) << "Using " << argv[argptr] << " as elements database." << endl);
               strncpy (configuration.databasepath, argv[argptr], MAXSTRINGSIZE-1);
               argptr+=1;
@@ -1425,14 +1592,25 @@
           case 'g':
             if ((argptr >= argc) || (argv[argptr][0] == '-')) {
-              eLog() << Verbose(0) << "Not enough or invalid arguments for specifying bond length table: -g <table file>" << endl;
+              DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments for specifying bond length table: -g <table file>" << endl);
+              performCriticalExit();
             } else {
               BondGraphFileName = argv[argptr];
-              Log() << Verbose(0) << "Using " << BondGraphFileName << " as bond length table." << endl;
+              DoLog(0) && (Log() << Verbose(0) << "Using " << BondGraphFileName << " as bond length table." << endl);
               argptr+=1;
             }
             break;
           case 'n':
-            Log() << Verbose(0) << "I won't parse trajectories." << endl;
+            DoLog(0) && (Log() << Verbose(0) << "I won't parse trajectories." << endl);
             configuration.FastParsing = true;
+            break;
+          case 'X':
+            {
+              char **name = &(World::get()->DefaultName);
+              delete[](*name);
+              const int length = strlen(argv[argptr]);
+              *name = new char[length+2];
+              strncpy(*name, argv[argptr], length);
+              DoLog(0) && (Log() << Verbose(0) << "Default name of new molecules set to " << *name << "." << endl);
+            }
             break;
           default:   // no match? Step on
@@ -1446,8 +1624,8 @@
     // 3a. Parse the element database
     if (periode->LoadPeriodentafel(configuration.databasepath)) {
-      Log() << Verbose(0) << "Element list loaded successfully." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Element list loaded successfully." << endl);
       //periode->Output();
     } else {
-      Log() << Verbose(0) << "Element list loading failed." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Element list loading failed." << endl);
       return 1;
     }
@@ -1455,5 +1633,5 @@
     if (argv[1][0] != '-') {
       // simply create a new molecule, wherein the config file is loaded and the manipulation takes place
-      Log() << Verbose(0) << "Config file given." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Config file given." << endl);
       test.open(argv[1], ios::in);
       if (test == NULL) {
@@ -1461,8 +1639,8 @@
         output.open(argv[1], ios::out);
         if (output == NULL) {
-          Log() << Verbose(1) << "Specified config file " << argv[1] << " not found." << endl;
+          DoLog(1) && (Log() << Verbose(1) << "Specified config file " << argv[1] << " not found." << endl);
           configPresent = absent;
         } else {
-          Log() << Verbose(0) << "Empty configuration file." << endl;
+          DoLog(0) && (Log() << Verbose(0) << "Empty configuration file." << endl);
           ConfigFileName = argv[1];
           configPresent = empty;
@@ -1472,18 +1650,18 @@
         test.close();
         ConfigFileName = argv[1];
-        Log() << Verbose(1) << "Specified config file found, parsing ... ";
+        DoLog(1) && (Log() << Verbose(1) << "Specified config file found, parsing ... ");
         switch (configuration.TestSyntax(ConfigFileName, periode)) {
           case 1:
-            Log() << Verbose(0) << "new syntax." << endl;
+            DoLog(0) && (Log() << Verbose(0) << "new syntax." << endl);
             configuration.Load(ConfigFileName, BondGraphFileName, periode, molecules);
             configPresent = present;
             break;
           case 0:
-            Log() << Verbose(0) << "old syntax." << endl;
+            DoLog(0) && (Log() << Verbose(0) << "old syntax." << endl);
             configuration.LoadOld(ConfigFileName, BondGraphFileName, periode, molecules);
             configPresent = present;
             break;
           default:
-            Log() << Verbose(0) << "Unknown syntax or empty, yet present file." << endl;
+            DoLog(0) && (Log() << Verbose(0) << "Unknown syntax or empty, yet present file." << endl);
             configPresent = empty;
        }
@@ -1502,5 +1680,15 @@
        mol = new molecule(periode);
        mol->ActiveFlag = true;
+       if (ConfigFileName != NULL)
+         mol->SetNameFromFilename(ConfigFileName);
        molecules->insert(mol);
+     }
+     if (configuration.BG == NULL) {
+       configuration.BG = new BondGraph(configuration.GetIsAngstroem());
+       if ((!BondGraphFileName.empty()) && (configuration.BG->LoadBondLengthTable(BondGraphFileName))) {
+         DoLog(0) && (Log() << Verbose(0) << "Bond length table loaded successfully." << endl);
+       } else {
+         DoeLog(1) && (eLog()<< Verbose(1) << "Bond length table loading failed." << endl);
+       }
      }
 
@@ -1508,5 +1696,5 @@
     argptr = 1;
     do {
-      Log() << Verbose(0) << "Current Command line argument: " << argv[argptr] << "." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Current Command line argument: " << argv[argptr] << "." << endl);
       if (argv[argptr][0] == '-') {
         argptr++;
@@ -1517,12 +1705,13 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-')) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough arguments for parsing: -p <xyz file>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough arguments for parsing: -p <xyz file>" << endl);
+                performCriticalExit();
               } else {
                 SaveFlag = true;
-                Log() << Verbose(1) << "Parsing xyz file for new atoms." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Parsing xyz file for new atoms." << endl);
                 if (!mol->AddXYZFile(argv[argptr]))
-                  Log() << Verbose(2) << "File not found." << endl;
+                  DoLog(2) && (Log() << Verbose(2) << "File not found." << endl);
                 else {
-                  Log() << Verbose(2) << "File found and parsed." << endl;
+                  DoLog(2) && (Log() << Verbose(2) << "File found and parsed." << endl);
                   configPresent = present;
                 }
@@ -1533,12 +1722,13 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3]))) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments for adding atom: -a <element> <x> <y> <z>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments for adding atom: -a <element> <x> <y> <z>" << endl);
+                performCriticalExit();
               } else {
                 SaveFlag = true;
-                Log() << Verbose(1) << "Adding new atom with element " << argv[argptr] << " at (" << argv[argptr+1] << "," << argv[argptr+2] << "," << argv[argptr+3] << "), ";
+                DoLog(1) && (Log() << Verbose(1) << "Adding new atom with element " << argv[argptr] << " at (" << argv[argptr+1] << "," << argv[argptr+2] << "," << argv[argptr+3] << "), ");
                 first = new atom;
                 first->type = periode->FindElement(atoi(argv[argptr]));
                 if (first->type != NULL)
-                  Log() << Verbose(2) << "found element " << first->type->name << endl;
+                  DoLog(2) && (Log() << Verbose(2) << "found element " << first->type->name << endl);
                 for (int i=NDIM;i--;)
                   first->x.x[i] = atof(argv[argptr+1+i]);
@@ -1548,5 +1738,5 @@
                     configPresent = present;
                 } else
-                  eLog() << Verbose(1) << "Could not find the specified element." << endl;
+                  DoeLog(1) && (eLog()<< Verbose(1) << "Could not find the specified element." << endl);
                 argptr+=4;
               }
@@ -1561,8 +1751,9 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-')) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for setting MPQC basis: -B <basis name>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for setting MPQC basis: -B <basis name>" << endl);
+                performCriticalExit();
               } else {
                 configuration.basis = argv[argptr];
-                Log() << Verbose(1) << "Setting MPQC basis to " << configuration.basis << "." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Setting MPQC basis to " << configuration.basis << "." << endl);
                 argptr+=1;
               }
@@ -1571,5 +1762,5 @@
               if (ExitFlag == 0) ExitFlag = 1;
               {
-                Log() << Verbose(1) << "Depth-First-Search Analysis." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Depth-First-Search Analysis." << endl);
                 MoleculeLeafClass *Subgraphs = NULL;      // list of subgraphs from DFS analysis
                 int *MinimumRingSize = new int[mol->AtomCount];
